#pragma once
#include <list>
namespace autocar
{
namespace vision_mul
{
class Predictor {
public:
    Predictor(int _history_size = 5,double f_ = 630)
        : history_size(_history_size),f(f_),old_first_frame(0),first_frame(0){}
    bool setFocus(double f_)
    {
      this->f = f_;
      return true;
    }
    bool setRecord(double value, double time);

    // Using history data to predict the query value
    // (fit the data using quadratic curve at min MSE criterion)
    double predict(double time);
    void setFrames();
    void clear(){
        history_value.clear();
        history_time.clear();
    }

private:
    std::list<double> history_value;
    std::list<double> history_time;
    int history_size;
    double first_frame;
    double old_first_frame;
    double f;
};
}
}